/*
    EZLeser - a paystub reader (Einzahlungsschein Leser)

    Copyright (C) 2008-2009  David Mosberger-Tang <dmosberger@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
var EZBusy;
var EZData;
var EZDataCleared = false;

function ezfill () {
    if (EZData) {
	if (EZDataCleared)
	    v = "((e[j].value == v[m[e[j].name]]) ? \"\" : e[j].value)";
	else
	    v = "v[m[e[j].name]]";
	loadURI("javascript:(function () {" +
		EZData +
		"e=document.getElementsByTagName(\"input\");" +
		"for (j=0;j<e.length;++j)" +
		"  if (!(e[j].disabled || e[j].readonly)" +
		"      && m[e[j].name] && v[m[e[j].name]])" +
		"    e[j].value = " + v + ";" +
		"})();");
    }
}

function ezclear () {
    EZDataCleared = true;
    ezfill();
    var e = document.getElementById("ez-status");
    if (e)
	e.label = "EZ Leser: Bereit";
}

function ezlesen () {
    var timeout = 0;
    var em = Components.classes["@mozilla.org/extensions/manager;1"].
	getService(Components.interfaces.nsIExtensionManager);
    var props = Components.classes["@mozilla.org/file/directory_service;1"].
	getService(Components.interfaces.nsIProperties);
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].
	getService(Components.interfaces.nsIPrefService);
    prefs = prefs.getBranch("extensions.ezleser.");

    var e = document.getElementById("ez-status");
    if (EZBusy) {
	if (e)
	    e.label = "EZ-Leser: Schon am Arbeiten...";
	return;
    }
    EZBusy = true;
    EZDataCleared = false;

    // Get hold of "ezleser" program:
    var my_id = "ezleser@mosberger-consulting.com";
    var prog = em.getInstallLocation(my_id).getItemFile(my_id, "bin/ezleser");

    // Create a temporary file:
    var tmp = props.get("TmpD", Components.interfaces.nsIFile);
    tmp.append("ezLeserOutput.xml");
    tmp.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0666);

    var process = Components.classes["@mozilla.org/process/util;1"].
	createInstance(Components.interfaces.nsIProcess);
    process.init(prog);
    var args = [ tmp.path ];

    try {
	var dev = prefs.getCharPref("scanner");
	if (dev)
	    args[args.length] = dev;
    } catch (e) {
    }

    if (e)
	e.label = "EZ-Leser: Am Dokument Lesen";

    process.run(false, args, args.length);

    function checkOutput(tmp) {
	var f = Components.classes["@mozilla.org/network/file-input-stream;1"].
	    createInstance(Components.interfaces.nsIFileInputStream);
	f.init(tmp, -1, 0, 0);

	if (f.available() == 0) {
	    if (timeout++ > 300) {
		if (e)
		    e.label = "EZ-Leser: Schein einlesen fehlgeschlagen ";
		else
		    alert("Schein einlesen fehlgeschlagen");
		tmp.remove(false);
		EZBusy = false;
		return;
	    }
	    window.setTimeout(function () { checkOutput(tmp); }, 100);
	    return;
	}
	var parser = new DOMParser();
	xml = parser.parseFromStream(f, 0, f.available(), "text/xml");

	tmp.remove(false);

	if (!xml) {
	    if (e)
		e.label = "EZ-Leser: Keine Werte gefunden";
	    else
		alert("Fehler whrend dem Einlesen (xml==NULL).");
	    EZBusy = false;
	    return;
	}

	var mstr = "m={};";
	var map = xml.getElementsByTagName("map");
	for (var i = 0; i < map.length; ++i) {
	    var n = map[i].getAttribute("name");
	    var f = map[i].textContent;
	    mstr += "m." + n + '="' + f + '";';
	}
	//  alert("map=" + mstr);

	vstr = "v={};";
	var val = xml.getElementsByTagName("val");
	for (var i = 0; i < val.length; ++i) {
	    var n = val[i].getAttribute("name");
	    var v = val[i].textContent;
	    vstr += "v." + n + '="' + v + '";';
	}

	if (e)
	    e.label = "EZ-Leser: " + val.length + " Werte gefunden";

	EZData = mstr + vstr;
	ezfill();
	EZBusy = false;
    }
    window.setTimeout(function () { checkOutput(tmp); }, 100);
}

document.addEventListener("DOMContentLoaded", ezfill, true);
